include:
  - project: "empaia/integration/ci-templates"
    ref: "main"
    file:
      - "pipeline-templates/pipeline-poetry-standard.yml"
      - "job-templates/docker-init.yml"
      - "job-templates/poetry-codecheck.yml"

variables:
  TITLE: "WBS"
  DESCRIPTION: "Workbench Service (WBS)"
  DIRECTORY: "workbench_service"
  TEST_DIRECTORY: "tests"
  RUNNER_TAG: "empaia-parallel"
  RUNNER_DOCKER_TAG: "empaia-docker"
  HOST_PORT: 8000
  CONTAINER_PORT: 8000

poetry-codecheck-tests:
  extends: .poetry-codecheck
  variables:
    DIRECTORY: "tests"

poetry-codecheck-tests-auth:
  extends: .poetry-codecheck
  variables:
    DIRECTORY: "tests_auth"

docker-based-pytest:
  extends: .docker-init
  tags:
    - empaia-docker
  before_script:
    - !reference [.docker-init, before_script]
    - cp sample.env .env
    - docker compose up --build -d
    - poetry install
    - sleep 5
  script:
    - poetry run pytest tests --maxfail=1
  after_script:
    - docker compose down -v
    - !reference [.docker-init, after_script]

docker-based-pytest-auth:
  extends: .docker-init
  tags:
    - empaia-docker
  before_script:
    - !reference [.docker-init, before_script]
    - cp sample_auth.env .env
    - docker compose up --build -d
    - poetry install
    - sleep 5
  script:
    - poetry run pytest tests_auth --maxfail=1
  after_script:
    - docker compose down -v
    - !reference [.docker-init, after_script]


docker-build-and-push:
  needs:
    - !reference [.docker-build-and-push-default-needs, needs]
    - job: docker-based-pytest
    - job: docker-based-pytest-auth
    - job: poetry-codecheck-tests
    - job: poetry-codecheck-tests-auth
